import { DataAnnotation } from './DataAnnotation';
import { Property } from './Property';
import { Record } from './Record';
import { TypeNames } from './types';
/**
 * An empty or uninitialized {@link Record}.
 * Represents a 'Record' or set of {@link Property} (names and values).
 * An Record may also have {@link Annotation}s (style annotations) that apply to the whole 'record'
 */
export declare class NullRecord implements Record {
    static singleton: NullRecord;
    readonly annotations: DataAnnotation[];
    annotationsAtName(propName: string): DataAnnotation[];
    afterEffects(after: Record): Record;
    readonly backgroundColor: string;
    backgroundColorFor(propName: string): string;
    readonly foregroundColor: string;
    foregroundColorFor(propName: string): string;
    readonly id: string;
    readonly imageName: string;
    imageNameFor(propName: string): string;
    readonly imagePlacement: string;
    imagePlacementFor(propName: string): string;
    readonly isBoldText: boolean;
    isBoldTextFor(propName: string): boolean;
    readonly isItalicText: boolean;
    isItalicTextFor(propName: string): boolean;
    readonly isPlacementCenter: boolean;
    isPlacementCenterFor(propName: string): boolean;
    readonly isPlacementLeft: boolean;
    isPlacementLeftFor(propName: string): boolean;
    readonly isPlacementRight: boolean;
    isPlacementRightFor(propName: string): boolean;
    readonly isPlacementStretchUnder: boolean;
    isPlacementStretchUnderFor(propName: string): boolean;
    readonly isPlacementUnder: boolean;
    isPlacementUnderFor(propName: string): boolean;
    readonly isUnderline: boolean;
    isUnderlineFor(propName: string): boolean;
    readonly overrideText: string;
    overrideTextFor(propName: string): string;
    propAtIndex(index: number): Property;
    propAtName(propName: string): Property;
    readonly propCount: number;
    readonly propNames: string[];
    readonly properties: Property[];
    readonly propValues: any[];
    readonly tipText: string;
    readonly type: string;
    tipTextFor(propName: string): string;
    toRecord(): Record;
    toJSON(): {
        id: string;
        properties: Property[];
        type: TypeNames;
    };
    valueAtName(propName: string): any;
}
